/* This is an example of the use of counters.

   Written by Mark Overmars

   Date: 29 Apr 1991
*/

#include <stdio.h>
#include <gl/gl.h>
#include "forms.h"


FL_FORM *form;

FL_OBJECT *result, *button, *co[3];

void create_form_form()
{
  FL_OBJECT *obj;
  form = fl_bgn_form(FL_NO_BOX,480.0,200.0);
  obj = fl_add_box(FL_UP_BOX,0.0,0.0,480.0,200.0,"");
  result = obj = fl_add_box(FL_DOWN_BOX,310.0,20.0,150.0,160.0,"");
  co[0] = obj = fl_add_counter(FL_NORMAL_COUNTER,20.0,150.0,270.0,30.0,"");
    fl_set_object_color(obj,9,1);
  co[1] = obj = fl_add_counter(FL_NORMAL_COUNTER,20.0,110.0,270.0,30.0,"");
    fl_set_object_color(obj,10,2);
  co[2] = obj = fl_add_counter(FL_NORMAL_COUNTER,20.0,70.0,270.0,30.0,"");
    fl_set_object_color(obj,12,4);
  button = obj = fl_add_button(FL_NORMAL_BUTTON,100.0,20.0,110.0,30.0,"Exit");
  fl_end_form();
}

main()
{
  FL_OBJECT *ret;
  int i,r,g,b;
  fl_init();
  create_form_form();
  fl_set_object_color(result,200,200);
  for (i=0; i<3; i++)
  {
    fl_set_counter_bounds(co[i],0.0,255.0);
    fl_set_counter_step(co[i],1.0,16.0);
    fl_set_counter_precision(co[i],0);
    fl_set_counter_return(co[i],TRUE);
  }
  fl_show_form(form,FL_PLACE_CENTER,FALSE,NULL);
  do
  {
    r = (int) fl_get_counter_value(co[0]);
    g = (int) fl_get_counter_value(co[1]);
    b = (int) fl_get_counter_value(co[2]);
    fl_mapcolor(200,r,g,b);
    fl_redraw_object(result);
    ret = fl_do_forms();
  } while (ret != button);
  fl_hide_form(form);
}
